diff -uwr source/scripts/gmgame.cpp 4.0/source/scripts/gmgame.cpp
--- source/scripts/gmgame.cpp	2011-09-04 17:08:04.000000000 +0800
+++ 4.0/source/scripts/gmgame.cpp	2011-10-14 21:29:00.915039000 +0800
@@ -1,3 +1,14 @@
+/*	Renegade Scripts.dll
+	Copyright 2011 Tiberian Technologies
+
+	This file is part of the Renegade scripts.dll
+	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
+	the terms of the GNU General Public License as published by the Free
+	Software Foundation; either version 2, or (at your option) any later
+	version. See the file COPYING for more details.
+	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
+	Only the source code to the module(s) containing the licenced code has to be released.
+*/
 #include "General.h"
 #include "gmgame.h"
 #include "engine.h"
@@ -189,7 +200,8 @@
 	if (SSGMIni)
 	{
 		ReadConfig(SSGMIni);
-
+		unsigned short port = (unsigned short)SSGMIni->Get_Int("General","Port",0);
+		SSGMGameLog::Init(port);
 		int count = SSGMIni->Entry_Count("Plugins");
 		for (int i = 0;i < count;i++)
 		{
@@ -240,10 +252,12 @@
 	AddThinkHook(ThinkHook);
 	AddConsoleOutputHook(ConsoleOutputHook);
 	AddLogFileHook(LogFileHook);
+	AddRefillHook(RefillHook);
 }
 
 void SSGMGameManager::Shutdown()
 {
+	SSGMGameLog::Shutdown();
 	FreeData();
 	FreeMapData();
 	for (int i = 0;i < Plugins.Count();i++)
@@ -376,17 +390,17 @@
 		if (DisableExtraWeapons)
 		{
 			const SimpleDynVecClass<GameObjObserverClass *> &observers = obj->Get_Observers();
-			SimpleDynVecClass<GameObjObserverClass *> deleteobservers;
+			SimpleDynVecClass<ScriptImpClass *> deleteobservers;
 			for (int i = 0;i < observers.Count();i++)
 			{
 				if (!_stricmp(observers[i]->Get_Name(),"M00_GrantPowerup_Created"))
 				{
-					deleteobservers.Add(observers[i]);
+					deleteobservers.Add((ScriptImpClass *)observers[i]);
 				}
 			}
 			for (int i = 0;i < deleteobservers.Count();i++)
 			{
-				obj->Remove_Observer(deleteobservers[i]);
+				deleteobservers[i]->Destroy_Script();
 			}
 		}
 		Attach_Script_Once(obj,"SSGM_Soldier","");
@@ -447,7 +461,6 @@
 	delete[] GDISpawnChar;
 	delete[] NodSpawnChar;
 	delete[] ObjectsFilename;
-	SSGMGameLog::Shutdown();
 	for (int i = 0;i < RegisteredEvents[EVENT_GLOBAL_INI].Count();i++)
 	{
 		RegisteredEvents[EVENT_GLOBAL_INI][i]->OnFreeData();
@@ -570,8 +583,6 @@
 			SSGMIni->Get_String(translation,"Translation_Overrides",Entry);
 			Translation_Overrides.Insert(Entry,translation);
 		}
-		unsigned short port = (unsigned short)SSGMIni->Get_Int("General","Port",0);
-		SSGMGameLog::Init(port);
 		for (int i = 0;i < RegisteredEvents[EVENT_GLOBAL_INI].Count();i++)
 		{
 			RegisteredEvents[EVENT_GLOBAL_INI][i]->OnLoadGlobalINISettings(SSGMIni);
@@ -1225,21 +1236,6 @@
 		}
 		else if ( (strstr(Commands->Get_Preset_Name(obj),"POW_Chaingun_Player")) || (strstr(Commands->Get_Preset_Name(obj),"POW_Chaingun_Player_Nod")) )
 		{
-			if ( (Has_Weapon(sender,"Weapon_Chaingun_Player")) || (Has_Weapon(sender,"Weapon_Chaingun_Player_Nod")) )
-			{
-				Send_Message_Player(sender,104,234,40,"Chaingun ammunition acquired.");
-				Create_2D_WAV_Sound_Player(sender,"m00pacg_aqob0004i1evag_snd.wav");
-				if (!SBHCanPickupDropWeapons)
-				{
-					if (strcmp(Commands->Get_Preset_Name(sender),"CnC_Nod_FlameThrower_2SF") == 0)
-					{
-						Remove_Weapon(sender,"Weapon_Chaingun_Player");
-						Remove_Weapon(sender,"Weapon_Chaingun_Player_Nod");
-					}
-				}
-			}
-			else
-			{
 				Send_Message_Player(sender,104,234,40,"Chaingun acquired.");
 				Create_2D_WAV_Sound_Player(sender,"m00pwcg_aqob0004i1evag_snd.wav");
 				if (!SBHCanPickupDropWeapons)
@@ -1251,7 +1247,6 @@
 					}
 				}
 			}
-		}
 		else if (strstr(Commands->Get_Preset_Name(obj),"CnC_MineProximity_05"))
 		{
 			Send_Message_Player(sender,104,234,40,"Proximity C4 acquired.");
@@ -1266,20 +1261,6 @@
 		}
 		else if (strstr(Commands->Get_Preset_Name(obj),"POW_ChemSprayer_Player"))
 		{
-			if (Has_Weapon(sender,"Weapon_ChemSprayer_Player"))
-			{
-				Send_Message_Player(sender,104,234,40,"Chemsprayer fluid acquired.");
-				Create_2D_WAV_Sound_Player(sender,"m00pacs_aqob0004i1evag_snd.wav");
-				if (!SBHCanPickupDropWeapons)
-				{
-					if (strcmp(Commands->Get_Preset_Name(sender),"CnC_Nod_FlameThrower_2SF") == 0)
-					{
-						Remove_Weapon(sender,"Weapon_ChemSprayer_Player");
-					}
-				}
-			}
-			else
-			{
 				Send_Message_Player(sender,104,234,40,"Chemsprayer acquired.");
 				Create_2D_WAV_Sound_Player(sender,"m00pwcs_aqob0004i1evag_snd.wav");
 				if (!SBHCanPickupDropWeapons)
@@ -1290,7 +1271,6 @@
 					}
 				}
 			}
-		}
 		else if (strstr(Commands->Get_Preset_Name(obj),"CnC_POW_MineTimed_Player_02"))
 		{
 			Send_Message_Player(sender,104,234,40,"Timed C4 acquired.");
@@ -1305,20 +1285,6 @@
 		}
 		else if (strstr(Commands->Get_Preset_Name(obj),"POW_Flamethrower_Player"))
 		{
-			if (Has_Weapon(sender,"Weapon_Flamethrower_Player"))
-			{
-				Send_Message_Player(sender,104,234,40,"Flamethrower fuel acquired.");
-				Create_2D_WAV_Sound_Player(sender,"m00paft_aqob0001i1evag_snd.wav");
-				if (!SBHCanPickupDropWeapons)
-				{
-					if (strcmp(Commands->Get_Preset_Name(sender),"CnC_Nod_FlameThrower_2SF") == 0)
-					{
-						Remove_Weapon(sender,"Weapon_Flamethrower_Player");
-					}
-				}
-			}
-			else
-			{
 				Send_Message_Player(sender,104,234,40,"Flamethrower acquired.");
 				Create_2D_WAV_Sound_Player(sender,"m00pwft_aqob0001i1evag_snd.wav");
 				if (!SBHCanPickupDropWeapons)
@@ -1329,23 +1295,8 @@
 					}
 				}
 			}
-		}
 		else if (strstr(Commands->Get_Preset_Name(obj),"POW_GrenadeLauncher_Player"))
 		{
-			if (Has_Weapon(sender,"Weapon_GrenadeLauncher_Player"))
-			{
-				Send_Message_Player(sender,104,234,40,"Grenades acquired.");
-				Create_2D_WAV_Sound_Player(sender,"m00pagn_aqob0004i1evag_snd.wav");
-				if (!SBHCanPickupDropWeapons)
-				{
-					if (strcmp(Commands->Get_Preset_Name(sender),"CnC_Nod_FlameThrower_2SF") == 0)
-					{
-						Remove_Weapon(sender,"Weapon_GrenadeLauncher_Player");
-					}
-				}
-			}
-			else
-			{
 				Send_Message_Player(sender,104,234,40,"Grenade Launcher acquired.");
 				Create_2D_WAV_Sound_Player(sender,"m00pwgl_aqob0004i1evag_snd.wav");
 				if (!SBHCanPickupDropWeapons)
@@ -1356,7 +1307,6 @@
 					}
 				}
 			}
-		}
 		else if (strstr(Commands->Get_Preset_Name(obj),"CnC_POW_IonCannonBeacon_Player"))
 		{
 			Send_Message_Player(sender,104,234,40,"Ion Cannon Beacon acquired.");
@@ -1374,20 +1324,6 @@
 		}
 		else if (strstr(Commands->Get_Preset_Name(obj),"POW_LaserChaingun_Player"))
 		{
-			if (Has_Weapon(sender,"Weapon_LaserChaingun_Player"))
-			{
-				Send_Message_Player(sender,104,234,40,"Laser Chaingun battery acquired.");
-				Create_2D_WAV_Sound_Player(sender,"m00palc_aqob0004i1evag_snd.wav");
-				if (!SBHCanPickupDropWeapons)
-				{
-					if (strcmp(Commands->Get_Preset_Name(sender),"CnC_Nod_FlameThrower_2SF") == 0)
-					{
-						Remove_Weapon(sender,"Weapon_LaserChaingun_Player");
-					}
-				}
-			}
-			else
-			{
 				Send_Message_Player(sender,104,234,40,"Laser Chaingun acquired.");
 				Create_2D_WAV_Sound_Player(sender,"m00pwlc_aqob0004i1evag_snd.wav");
 				if (!SBHCanPickupDropWeapons)
@@ -1398,37 +1334,13 @@
 					}
 				}
 			}
-		}
 		else if (strstr(Commands->Get_Preset_Name(obj),"POW_LaserRifle_Player"))
 		{
-			if (Has_Weapon(sender,"Weapon_LaserRifle_Player"))
-			{
-				Send_Message_Player(sender,104,234,40,"Laser Rifle battery acquired.");
-				Create_2D_WAV_Sound_Player(sender,"m00palr_aqob0004i1evag_snd.wav");
-			}
-			else
-			{
 				Send_Message_Player(sender,104,234,40,"Laser Rifle acquired.");
 				Create_2D_WAV_Sound_Player(sender,"m00pwlr_aqob0004i1evag_snd.wav");
 			}
-		}
 		else if ((strstr(Commands->Get_Preset_Name(obj),"POW_VoltAutoRifle_Player")) || (strstr(Commands->Get_Preset_Name(obj),"CnC_POW_VoltAutoRifle_Player_Nod")))
 		{
-			if ( (Has_Weapon(sender,"Weapon_VoltAutoRifle_Player")) || (Has_Weapon(sender,"Weapon_VoltAutoRifle_Player_Nod")) )
-			{
-				Send_Message_Player(sender,104,234,40,"Volt Auto Rifle battery acquired.");
-				Create_2D_WAV_Sound_Player(sender,"m00pavr_aqob0004i1evag_snd.wav");
-				if (!SBHCanPickupDropWeapons)
-				{
-					if (strcmp(Commands->Get_Preset_Name(sender),"CnC_Nod_FlameThrower_2SF") == 0)
-					{
-						Remove_Weapon(sender,"Weapon_VoltAutoRifle_Player");
-						Remove_Weapon(sender,"Weapon_VoltAutoRifle_Player_Nod");
-					}
-				}
-			}
-			else
-			{
 				Send_Message_Player(sender,104,234,40,"Volt Auto Rifle acquired.");
 				Create_2D_WAV_Sound_Player(sender,"m00pwvr_aqob0004i1evag_snd.wav");
 				if (!SBHCanPickupDropWeapons)
@@ -1440,23 +1352,8 @@
 					}
 				}
 			}
-		}
 		else if (strstr(Commands->Get_Preset_Name(obj),"POW_Railgun_Player"))
 		{
-			if (Has_Weapon(sender,"Weapon_Railgun_Player"))
-			{
-				Send_Message_Player(sender,104,234,40,"Railgun ammunition acquired.");
-				Create_2D_WAV_Sound_Player(sender,"m00parg_aqob0004i1evag_snd.wav");
-				if (!SBHCanPickupDropWeapons)
-				{
-					if (strcmp(Commands->Get_Preset_Name(sender),"CnC_Nod_FlameThrower_2SF") == 0)
-					{
-						Remove_Weapon(sender,"Weapon_Railgun_Player");
-					}
-				}
-			}
-			else
-			{
 				Send_Message_Player(sender,104,234,40,"Railgun acquired.");
 				Create_2D_WAV_Sound_Player(sender,"m00pwrg_aqob0004i1evag_snd.wav");
 				if (!SBHCanPickupDropWeapons)
@@ -1467,24 +1364,8 @@
 					}
 				}
 			}
-		}
 		else if (strstr(Commands->Get_Preset_Name(obj),"POW_RamjetRifle_Player"))
 		{
-			if ( (Has_Weapon(sender,"CnC_Weapon_RamjetRifle_Player")) || (Has_Weapon(sender,"Weapon_RamjetRifle_Player")) )
-			{
-				Send_Message_Player(sender,104,234,40,"Ramjet Rifle ammunition acquired.");
-				Create_2D_WAV_Sound_Player(sender,"m00parj_aqob0004i1evag_snd.wav");
-				if (!SBHCanPickupDropWeapons)
-				{
-					if (strcmp(Commands->Get_Preset_Name(sender),"CnC_Nod_FlameThrower_2SF") == 0)
-					{
-						Remove_Weapon(sender,"CnC_Weapon_RamjetRifle_Player");
-						Remove_Weapon(sender,"Weapon_RamjetRifle_Player");
-					}
-				}
-			}
-			else
-			{
 				Send_Message_Player(sender,104,234,40,"Ramjet Rifle acquired.");
 				Create_2D_WAV_Sound_Player(sender,"m00pwrj_aqob0004i1evag_snd.wav");
 				if (!SBHCanPickupDropWeapons)
@@ -1496,26 +1377,10 @@
 					}
 				}
 			}
-		}
 		else if ((strstr(Commands->Get_Preset_Name(obj),"POW_RocketLauncher_Player")) || 
 			     (strstr(Commands->Get_Preset_Name(obj),"CnC_POW_RocketLauncher_Player")) || 
 				 (strstr(Commands->Get_Preset_Name(obj),"M02_POW_Rocket_FullAmmo")) )
 		{
-			if ( (Has_Weapon(sender,"Weapon_RocketLauncher_Player")) || (Has_Weapon(sender,"CnC_Weapon_RocketLauncher_Player")) )
-			{
-				Send_Message_Player(sender,104,234,40,"Rockets acquired.");
-				Create_2D_WAV_Sound_Player(sender,"m00park_aqob0004i1evag_snd.wav");
-				if (!SBHCanPickupDropWeapons)
-				{
-					if (strcmp(Commands->Get_Preset_Name(sender),"CnC_Nod_FlameThrower_2SF") == 0)
-					{
-						Remove_Weapon(sender,"Weapon_RocketLauncher_Player");
-						Remove_Weapon(sender,"CnC_Weapon_RocketLauncher_Player");
-					}
-				}
-			}
-			else
-			{
 				Send_Message_Player(sender,104,234,40,"Rocket Launcher acquired.");
 				Create_2D_WAV_Sound_Player(sender,"m00pwrl_aqob0004i1evag_snd.wav");
 				if (!SBHCanPickupDropWeapons)
@@ -1527,24 +1392,8 @@
 					}
 				}
 			}
-		}
 		else if (strstr(Commands->Get_Preset_Name(obj),"CnC_POW_RepairGun_Player"))
 		{
-			if (Has_Weapon(sender,"Weapon_RepairGun_Player"))
-			{
-				Send_Message_Player(sender,104,234,40,"Maintenance Tool Battery acquired.");
-				Create_2D_WAV_Sound_Player(sender,"m00parp_aqob0004i1evag_snd.wav");
-				Remove_Weapon(sender,"Weapon_RepairGun_Player");//remove the dubplicate weak repairgun
-				if (!SBHCanPickupDropWeapons)
-				{
-					if (strcmp(Commands->Get_Preset_Name(sender),"CnC_Nod_FlameThrower_2SF") == 0)
-					{
-						Remove_Weapon(sender,"Weapon_RepairGun_Player");
-					}
-				}
-			}
-			else
-			{
 				Send_Message_Player(sender,104,234,40,"Maintenance Tool acquired.");
 				Create_2D_WAV_Sound_Player(sender,"m00pwrp_aqob0001i1evag_snd.wav");
 				if (!SBHCanPickupDropWeapons)
@@ -1555,24 +1404,8 @@
 					}
 				}
 			}
-		}
 		else if (strstr(Commands->Get_Preset_Name(obj),"POW_RepairGun_Player"))		
 		{
-			if (Has_Weapon(sender,"CnC_Weapon_RepairGun_Player_Special"))
-			{
-				Send_Message_Player(sender,104,234,40,"Maintenance Tool Battery acquired.");
-				Create_2D_WAV_Sound_Player(sender,"m00parp_aqob0004i1evag_snd.wav");
-				Remove_Weapon(sender,"Weapon_RepairGun_Player");//remove the dubplicate weak repairgun
-				if (!SBHCanPickupDropWeapons)
-				{
-					if (strcmp(Commands->Get_Preset_Name(sender),"CnC_Nod_FlameThrower_2SF") == 0)
-					{
-						Remove_Weapon(sender,"CnC_Weapon_RepairGun_Player_Special");
-					}
-				}
-			}
-			else
-			{
 				Send_Message_Player(sender,104,234,40,"Maintenance Tool acquired.");
 				Create_2D_WAV_Sound_Player(sender,"m00pwrp_aqob0001i1evag_snd.wav");
 				if (!SBHCanPickupDropWeapons)
@@ -1583,27 +1416,8 @@
 					}
 				}
 			}
-		}
 		else if ((strstr(Commands->Get_Preset_Name(obj),"POW_SniperRifle_Player")) || (strstr(Commands->Get_Preset_Name(obj),"POW_SniperRifle_Player_Nod")))
 		{
-			if ( (Has_Weapon(sender,"Weapon_SniperRifle_Player")) || (Has_Weapon(sender,"CnC_Weapon_SniperRifle_Player")) || 
-				 (Has_Weapon(sender,"Weapon_SniperRifle_Player_Nod")) || (Has_Weapon(sender,"CnC_Weapon_SniperRifle_Player_Nod")) )
-			{
-				Send_Message_Player(sender,104,234,40,"Sniper Rifle ammunition acquired.");
-				Create_2D_WAV_Sound_Player(sender,"m00pasr_aqob0004i1evag_snd.wav");
-				if (!SBHCanPickupDropWeapons)
-				{
-					if (strcmp(Commands->Get_Preset_Name(sender),"CnC_Nod_FlameThrower_2SF") == 0)
-					{
-						Remove_Weapon(sender,"Weapon_SniperRifle_Player");
-						Remove_Weapon(sender,"Weapon_SniperRifle_Player_Nod");
-						Remove_Weapon(sender,"CnC_Weapon_SniperRifle_Player");
-						Remove_Weapon(sender,"CnC_Weapon_SniperRifle_Player_Nod");
-					}
-				}
-			}
-			else
-			{
 				Send_Message_Player(sender,104,234,40,"Sniper Rifle acquired.");
 				Create_2D_WAV_Sound_Player(sender,"m00pwsr_aqob0004i1evag_snd.wav");
 				if (!SBHCanPickupDropWeapons)
@@ -1617,23 +1431,8 @@
 					}
 				}
 			}
-		}
 		else if (strstr(Commands->Get_Preset_Name(obj),"POW_Shotgun_Player"))
 		{
-			if (Has_Weapon(sender,"Weapon_Shotgun_Player"))
-			{
-				Send_Message_Player(sender,104,234,40,"Shotgun ammunition acquired.");
-				Create_2D_WAV_Sound_Player(sender,"m00pass_aqob0004i1evag_snd.wav");
-				if (!SBHCanPickupDropWeapons)
-				{
-					if (strcmp(Commands->Get_Preset_Name(sender),"CnC_Nod_FlameThrower_2SF") == 0)
-					{
-						Remove_Weapon(sender,"Weapon_Shotgun_Player");
-					}
-				}
-			}
-			else
-			{
 				Send_Message_Player(sender,104,234,40,"Shotgun acquired.");
 				Create_2D_WAV_Sound_Player(sender,"m00pwps_aqob0004i1evag_snd.wav");
 				if (!SBHCanPickupDropWeapons)
@@ -1644,23 +1443,8 @@
 					}
 				}
 			}
-		}
 		else if (strstr(Commands->Get_Preset_Name(obj),"POW_TiberiumFlechetteGun_Player"))
 		{
-			if (Has_Weapon(sender,"Weapon_TiberiumFlechetteGun_Player"))
-			{
-				Send_Message_Player(sender,104,234,40,"Tiberium Flechette ammunition acquired.");
-				Create_2D_WAV_Sound_Player(sender,"m00patf_aqob0004i1evag_snd.wav");
-				if (!SBHCanPickupDropWeapons)
-				{
-					if (strcmp(Commands->Get_Preset_Name(sender),"CnC_Nod_FlameThrower_2SF") == 0)
-					{
-						Remove_Weapon(sender,"Weapon_TiberiumFlechetteGun_Player");
-					}
-				}
-			}
-			else
-			{
 				Send_Message_Player(sender,104,234,40,"Tiberium Flechette Rifle acquired.");
 				Create_2D_WAV_Sound_Player(sender,"m00pwtf_aqob0004i1evag_snd.wav");
 				if (!SBHCanPickupDropWeapons)
@@ -1671,23 +1455,8 @@
 					}
 				}
 			}
-		}
 		else if (strstr(Commands->Get_Preset_Name(obj),"POW_TiberiumAutoRifle_Player"))
 		{
-			if (Has_Weapon(sender,"Weapon_TiberiumAutoRifle_Player"))
-			{
-				Send_Message_Player(sender,104,234,40,"Tiberium Auto Rifle ammunition acquired.");
-				Create_2D_WAV_Sound_Player(sender,"m00patr_aqob0004i1evag_snd.wav");
-				if (!SBHCanPickupDropWeapons)
-				{
-					if (strcmp(Commands->Get_Preset_Name(sender),"CnC_Nod_FlameThrower_2SF") == 0)
-					{
-						Remove_Weapon(sender,"Weapon_TiberiumAutoRifle_Player");
-					}
-				}
-			}
-			else
-			{
 				Send_Message_Player(sender,104,234,40,"Tiberium Auto Rifle acquired.");
 				Create_2D_WAV_Sound_Player(sender,"m00pwtr_aqob0004i1evag_snd.wav");
 				if (!SBHCanPickupDropWeapons)
@@ -1698,7 +1467,6 @@
 					}
 				}
 			}
-		}
 		else if ( (strstr(Commands->Get_Preset_Name(obj),"CnC_POW_Armor_Max")) || (strstr(Commands->Get_Preset_Name(obj),"POW_Armor_100")) )
 		{
 			Send_Message_Player(sender,104,234,40,"Full Body Armor acquired.");
@@ -1726,20 +1494,6 @@
 		}
 		else if (strstr(Commands->Get_Preset_Name(obj),"POW_AutoRifle_Player"))		
 		{
-			if (Has_Weapon(sender,"Weapon_AutoRifle_Player"))
-			{
-				Send_Message_Player(sender,104,234,40,"Automatic Rifle ammunition acquired.");
-				Create_2D_WAV_Sound_Player(sender,"m00paar_aqob0004i1evag_snd.wav");
-				if (!SBHCanPickupDropWeapons)
-				{
-					if (strcmp(Commands->Get_Preset_Name(sender),"CnC_Nod_FlameThrower_2SF") == 0)
-					{
-						Remove_Weapon(sender,"Weapon_AutoRifle_Player");
-					}
-				}
-			}
-			else
-			{
 				Send_Message_Player(sender,104,234,40,"Automatic Rifle acquired.");
 				Create_2D_WAV_Sound_Player(sender,"m00pwar_aqob0004i1evag_snd.wav");
 				if (!SBHCanPickupDropWeapons)
@@ -1750,23 +1504,8 @@
 					}
 				}
 			}
-		}
 		else if (strstr(Commands->Get_Preset_Name(obj),"POW_AutoRifle_Player_Nod"))		
 		{
-			if (Has_Weapon(sender,"Weapon_AutoRifle_Player_Nod"))
-			{
-				Send_Message_Player(sender,104,234,40,"Automatic Rifle ammunition acquired.");
-				Create_2D_WAV_Sound_Player(sender,"m00paar_aqob0004i1evag_snd.wav");
-				if (!SBHCanPickupDropWeapons)
-				{
-					if (strcmp(Commands->Get_Preset_Name(sender),"CnC_Nod_FlameThrower_2SF") == 0)
-					{
-						Remove_Weapon(sender,"Weapon_AutoRifle_Player_Nod");
-					}
-				}
-			}
-			else
-			{
 				Send_Message_Player(sender,104,234,40,"Automatic Rifle acquired.");
 				Create_2D_WAV_Sound_Player(sender,"m00pwar_aqob0004i1evag_snd.wav");
 				if (!SBHCanPickupDropWeapons)
@@ -1777,7 +1516,6 @@
 					}
 				}
 			}
-		}
 	}
 }
 
diff -uwr source/scripts/gmgame.h 4.0/source/scripts/gmgame.h
--- source/scripts/gmgame.h	2011-08-30 23:20:46.000000000 +0800
+++ 4.0/source/scripts/gmgame.h	2011-10-11 21:52:45.681640600 +0800
@@ -1,3 +1,14 @@
+/*	Renegade Scripts.dll
+	Copyright 2011 Tiberian Technologies
+
+	This file is part of the Renegade scripts.dll
+	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
+	the terms of the GNU General Public License as published by the Free
+	Software Foundation; either version 2, or (at your option) any later
+	version. See the file COPYING for more details.
+	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
+	Only the source code to the module(s) containing the licenced code has to be released.
+*/
 #ifndef TT_INCLUDE_GMGAME_H
 #define TT_INCLUDE_GMGAME_H
 #include "gmplugin.h"
diff -uwr source/scripts/gmlog.cpp 4.0/source/scripts/gmlog.cpp
--- source/scripts/gmlog.cpp	2010-08-14 10:21:28.000000000 +0800
+++ 4.0/source/scripts/gmlog.cpp	2011-10-11 23:04:36.381835900 +0800
@@ -1,3 +1,14 @@
+/*	Renegade Scripts.dll
+	Copyright 2011 Tiberian Technologies
+
+	This file is part of the Renegade scripts.dll
+	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
+	the terms of the GNU General Public License as published by the Free
+	Software Foundation; either version 2, or (at your option) any later
+	version. See the file COPYING for more details.
+	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
+	Only the source code to the module(s) containing the licenced code has to be released.
+*/
 #include "general.h"
 #include "gmlog.h"
 #include "engine.h"
diff -uwr source/scripts/gmlog.h 4.0/source/scripts/gmlog.h
--- source/scripts/gmlog.h	2010-05-31 13:40:04.000000000 +0800
+++ 4.0/source/scripts/gmlog.h	2011-10-11 21:52:43.539062500 +0800
@@ -1,3 +1,14 @@
+/*	Renegade Scripts.dll
+	Copyright 2011 Tiberian Technologies
+
+	This file is part of the Renegade scripts.dll
+	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
+	the terms of the GNU General Public License as published by the Free
+	Software Foundation; either version 2, or (at your option) any later
+	version. See the file COPYING for more details.
+	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
+	Only the source code to the module(s) containing the licenced code has to be released.
+*/
 #ifndef TT_INCLUDE_GMLOG_H
 #define TT_INCLUDE_GMLOG_H
 
diff -uwr source/scripts/gmplugin.h 4.0/source/scripts/gmplugin.h
--- source/scripts/gmplugin.h	2011-08-30 23:20:46.000000000 +0800
+++ 4.0/source/scripts/gmplugin.h	2011-10-11 21:52:40.915039000 +0800
@@ -1,3 +1,14 @@
+/*	Renegade Scripts.dll
+	Copyright 2011 Tiberian Technologies
+
+	This file is part of the Renegade scripts.dll
+	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
+	the terms of the GNU General Public License as published by the Free
+	Software Foundation; either version 2, or (at your option) any later
+	version. See the file COPYING for more details.
+	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
+	Only the source code to the module(s) containing the licenced code has to be released.
+*/
 #ifndef TT_INCLUDE_GMPLUGIN_H
 #define TT_INCLUDE_GMPLUGIN_H
 #include "scripts.h"
diff -uwr source/scripts/gmsoldier.cpp 4.0/source/scripts/gmsoldier.cpp
--- source/scripts/gmsoldier.cpp	2011-08-20 09:50:42.000000000 +0800
+++ 4.0/source/scripts/gmsoldier.cpp	2011-10-11 23:04:34.123046800 +0800
@@ -1,3 +1,14 @@
+/*	Renegade Scripts.dll
+	Copyright 2011 Tiberian Technologies
+
+	This file is part of the Renegade scripts.dll
+	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
+	the terms of the GNU General Public License as published by the Free
+	Software Foundation; either version 2, or (at your option) any later
+	version. See the file COPYING for more details.
+	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
+	Only the source code to the module(s) containing the licenced code has to be released.
+*/
 #include "General.h"
 #include "scripts.h"
 #include "engine.h"
diff -uwr source/scripts/gmsoldier.h 4.0/source/scripts/gmsoldier.h
--- source/scripts/gmsoldier.h	2011-08-17 19:55:54.000000000 +0800
+++ 4.0/source/scripts/gmsoldier.h	2011-10-11 21:52:39.229492100 +0800
@@ -1,3 +1,14 @@
+/*	Renegade Scripts.dll
+	Copyright 2011 Tiberian Technologies
+
+	This file is part of the Renegade scripts.dll
+	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
+	the terms of the GNU General Public License as published by the Free
+	Software Foundation; either version 2, or (at your option) any later
+	version. See the file COPYING for more details.
+	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
+	Only the source code to the module(s) containing the licenced code has to be released.
+*/
 #ifndef TT_INCLUDE_GMSOLDIER_H
 #define TT_INCLUDE_GMSOLDIER_H
 class SSGM_Soldier : public ScriptImpClass {
diff -uwr source/scripts/gmvehicle.cpp 4.0/source/scripts/gmvehicle.cpp
--- source/scripts/gmvehicle.cpp	2011-08-29 08:56:56.000000000 +0800
+++ 4.0/source/scripts/gmvehicle.cpp	2011-10-11 23:04:32.766601500 +0800
@@ -1,3 +1,14 @@
+/*	Renegade Scripts.dll
+	Copyright 2011 Tiberian Technologies
+
+	This file is part of the Renegade scripts.dll
+	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
+	the terms of the GNU General Public License as published by the Free
+	Software Foundation; either version 2, or (at your option) any later
+	version. See the file COPYING for more details.
+	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
+	Only the source code to the module(s) containing the licenced code has to be released.
+*/
 #include "General.h"
 #include "scripts.h"
 #include "gmvehicle.h"
diff -uwr source/scripts/gmvehicle.h 4.0/source/scripts/gmvehicle.h
--- source/scripts/gmvehicle.h	2011-08-21 20:37:16.000000000 +0800
+++ 4.0/source/scripts/gmvehicle.h	2011-10-11 21:52:37.589843700 +0800
@@ -1,3 +1,14 @@
+/*	Renegade Scripts.dll
+	Copyright 2011 Tiberian Technologies
+
+	This file is part of the Renegade scripts.dll
+	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
+	the terms of the GNU General Public License as published by the Free
+	Software Foundation; either version 2, or (at your option) any later
+	version. See the file COPYING for more details.
+	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
+	Only the source code to the module(s) containing the licenced code has to be released.
+*/
 #ifndef TT_INCLUDE_GMVEHICLE_H
 #define TT_INCLUDE_GMVEHICLE_H
 class VehicleGameObj;
diff -uwr source/scripts/inttest.h 4.0/source/scripts/inttest.h
--- source/scripts/inttest.h	2009-11-09 18:58:08.000000000 +0800
+++ 4.0/source/scripts/inttest.h	2011-10-11 21:51:53.560546800 +0800
@@ -1,3 +1,14 @@
+/*	Renegade Scripts.dll
+	Copyright 2011 Tiberian Technologies
+
+	This file is part of the Renegade scripts.dll
+	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
+	the terms of the GNU General Public License as published by the Free
+	Software Foundation; either version 2, or (at your option) any later
+	version. See the file COPYING for more details.
+	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
+	Only the source code to the module(s) containing the licenced code has to be released.
+*/
 #ifndef TT_INCLUDE_INTTEST_H
 #define TT_INCLUDE_INTTEST_H
 #include "OBBoxClass.h"
diff -uwr source/scripts/jfwcine.cpp 4.0/source/scripts/jfwcine.cpp
--- source/scripts/jfwcine.cpp	2011-04-25 13:36:04.000000000 +0800
+++ 4.0/source/scripts/jfwcine.cpp	2011-10-11 23:05:22.311523400 +0800
@@ -1,6 +1,5 @@
 /*	Renegade Scripts.dll
-	Scripts to do with cinematics
-	Copyright 2010 Jonathan Wilson
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
diff -uwr source/scripts/jfwcine.h 4.0/source/scripts/jfwcine.h
--- source/scripts/jfwcine.h	2011-04-25 10:01:14.000000000 +0800
+++ 4.0/source/scripts/jfwcine.h	2011-10-14 22:27:31.998046800 +0800
@@ -1,6 +1,5 @@
 /*	Renegade Scripts.dll
-	Scripts to do with cinematics
-	Copyright 2010 Jonathan Wilson
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
@@ -10,6 +9,7 @@
 	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
 	Only the source code to the module(s) containing the licenced code has to be released.
 */
+#pragma once
 class JFW_Zone_Play_Cinematic : public ScriptImpClass {
 	void Entered(GameObject *obj,GameObject *enterer);
 };
diff -uwr source/scripts/jfwcust.cpp 4.0/source/scripts/jfwcust.cpp
--- source/scripts/jfwcust.cpp	2011-04-25 18:24:06.000000000 +0800
+++ 4.0/source/scripts/jfwcust.cpp	2011-10-11 23:05:21.089843700 +0800
@@ -1,6 +1,5 @@
 /*	Renegade Scripts.dll
-	Scripts that send and recieve customs
-	Copyright 2010 Jonathan Wilson
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
diff -uwr source/scripts/jfwcust.h 4.0/source/scripts/jfwcust.h
--- source/scripts/jfwcust.h	2011-04-25 18:24:06.000000000 +0800
+++ 4.0/source/scripts/jfwcust.h	2011-10-14 22:27:31.973632800 +0800
@@ -1,6 +1,5 @@
 /*	Renegade Scripts.dll
-	Scripts that send and recieve customs
-	Copyright 2010 Jonathan Wilson
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
@@ -10,6 +9,7 @@
 	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
 	Only the source code to the module(s) containing the licenced code has to be released.
 */
+#pragma once
 class JFW_Custom_Toggle_Radar : public ScriptImpClass {
 	void Custom(GameObject *obj,int type,int param,GameObject *sender);
 };
diff -uwr source/scripts/jfwdef.cpp 4.0/source/scripts/jfwdef.cpp
--- source/scripts/jfwdef.cpp	2010-05-28 14:55:54.000000000 +0800
+++ 4.0/source/scripts/jfwdef.cpp	2011-10-11 23:05:19.216796800 +0800
@@ -1,6 +1,5 @@
 /*	Renegade Scripts.dll
-	Base defense scripts
-	Copyright 2010 Olaf Van Der Spek, Jonathan Wilson
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
diff -uwr source/scripts/jfwdef.h 4.0/source/scripts/jfwdef.h
--- source/scripts/jfwdef.h	2010-05-25 22:03:52.000000000 +0800
+++ 4.0/source/scripts/jfwdef.h	2011-10-14 22:27:32.183593700 +0800
@@ -1,6 +1,5 @@
 /*	Renegade Scripts.dll
-	Base defense scripts
-	Copyright 2010 Olaf Van Der Spek, Jonathan Wilson
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
@@ -10,6 +9,7 @@
 	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
 	Only the source code to the module(s) containing the licenced code has to be released.
 */
+#pragma once
 class JFW_User_Controllable_Base_Defence : public ScriptImpClass {
 	unsigned int id1;
 	unsigned int id2;
diff -uwr source/scripts/jfwdmg.cpp 4.0/source/scripts/jfwdmg.cpp
--- source/scripts/jfwdmg.cpp	2011-08-21 10:36:58.000000000 +0800
+++ 4.0/source/scripts/jfwdmg.cpp	2011-10-11 23:05:17.557617100 +0800
@@ -1,6 +1,5 @@
 /*	Renegade Scripts.dll
-	Scripts to do with death, damage and health
-	Copyright 2010 Jonathan Wilson
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
